@echo off
:: MINIMUM requirements:
:: War2.. folder contains: Warcraft II BNE.exe (version 2.0.2.0)
:: War2..\Utils subfolder contains: War2BNEInSight104.exe and War2InSightAutorecord.exe
:: * Note : Avoid "'@,;=" symbols in War2Dir path string, and be careful with ".%"

:: normal use:
:: A. if you want to personalize path for saving war2insight replays, edit first line of War2InSightAutorecord.ini file, for example D:\insights
::      OR just delete War2InSightAutorecord.ini file. At next start you will be asked for new path. (if no any sensible choice then "War2Dir\Insights" will be used for replays autosaving).

:: B. if you have any issues with War2Insight window size at start, configure the game to start in Windowed mode.

:: C. if for some reason the path selection doesn't work, you need to do ONCE:
::       1. start Utils\War2BNEInSight104.exe,
::       2. manually open one file from folder that you want to be your replays store, to let your OS save last used folder info,
::       3. close War2BNEInSight104.

:: --- [for advanced users only]
set War2LoadTime=1
:: - base "sleep time" (x2 seconds that need to full war2 start. typical, before starting autorecord)

set War2WaitLim=2
:: - tries to check war2 presence.

cd /d "%~dp0"
set "War2Dir=%~dp0"
set "War2Dir=%War2Dir:~0,-1%"
set "War2LLog=%CD%\War2InSightAutorecord.log"
echo.&echo --- %date% %time:~0,8% started
echo --- %date% %time%>"%War2LLog%" started

:: checking War2Dir path string for hinder symbols to avoid unpredictable consequences
for /f "delims='@,;=" %%a in ("%War2Dir%") do set "var=%%a"
if /i "%var%"=="%War2Dir%" goto PathOK
echo %time:~0,8% PROBLEM: War2Dir path string contain illegal characters:
echo "%War2Dir%"
echo %time:~0,8% * Note : Avoid "'@,;=" symbols in War2Dir path string // and be careful with ".%"
echo %time:~0,8% Possible solution: Remove these characters by renaming Your War2 folder or reinstall War2 using correct path.
echo %time% PROBLEM: War2Dir path string contain illegal characters: "%War2Dir%">>"%War2LLog%"
echo %time% * Note : Avoid "@,;'=" symbols in War2Dir path string // and be careful with ".%%">>"%War2LLog%"
echo %time% Possible solution: Remove these characters by renaming your War2 folder or reinstall War2 using correct path.>>"%War2LLog%"
echo.
echo Please read information above, THEN press key to exit.&pause>nul &exit
:PathOK

:: --- [main]
set "War2StartNN=Warcraft II BNE.exe"
if not exist "%War2Dir%\%War2StartNN%" echo %time:~0,8% * Note : Wrong War2Dir setting. Using current Dir.&echo %time% * Note : Wrong War2Dir setting. Using current Dir.>>"%War2LLog%"&set War2Dir=%CD%
if not exist "%War2Dir%\%War2StartNN%" echo %time:~0,8% PROBLEM: Warcraft II BNE.exe not found. Press key to exit.&echo %time% PROBLEM:Warcraft II BNE.exe not found. Press key to exit.>>"%War2LLog%"&pause >nul &exit /b 2
set "w2ver=%War2Dir%\%War2StartNN%"
for /f "tokens=2 delims==" %%a in ('"wmic datafile where name='%w2ver:\=\\%' get Version /value|find "^=""') do set "w2ver=%%a"
if "%w2ver%"=="2.0.2.0" goto vOK
if "%w2ver%"=="2, 0, 2, 0" goto vOK
echo PROBLEM: Incompatible Warcraft II BNE.exe version (%w2ver%). Press key to exit.
echo PROBLEM: Incompatible Warcraft II BNE.exe version (%w2ver%). Press key to exit.>>"%War2LLog%"
pause >nul &exit /b 1
:vOK


echo %time:~0,8% War2Dir: "%War2Dir%"
echo %time% War2Dir: "%War2Dir%">>"%War2LLog%"
Set War2Insight=War2BNEInSight104.exe
if not exist "%War2Dir%\Utils\%War2Insight%" echo. &echo %time:~0,8% PROBLEM: \Utils\War2BNEInSight104 not found. Press key to exit.&echo %time% PROBLEM: \Utils\War2BNEInSight104 not found. Exiting.>>"%War2LLog%"&pause >nul &exit /b 2
if not exist "%War2Dir%\Utils\War2InSightAutorecord.exe" echo. &echo %time:~0,8% PROBLEM: \Utils\War2InSightAutorecord not found. Press key to exit.&echo %time% PROBLEM: \Utils\War2InSightAutorecord not found. Exiting.>>"%War2LLog%"&pause >nul &exit /b 2


TaskList /FI "ImageName EQ Warcraft II BNE.exe" 2>nul | Find /I "Warcraft II BNE.exe" >nul
set /a war2NotRunning=%ErrorLevel%
if %war2NotRunning% GTR 0 goto NoWar2
echo %time:~0,8% --- War2 found running.
echo %time% --- War2 found running.>>"%War2LLog%"
:NoWar2

call :PatchClose
TaskList 2>nul | Find /I "War2BNEInSight" >nul
If %ErrorLevel% EQU 1 goto NoInsightRunning
echo %time:~0,8% --- Found that War2Insight is already running! &echo.
echo %time% Found that War2Insight is already running!>>"%War2LLog%"
echo CHECK if you have UNSAVED replays in it, and save it, if needed.
echo If you are SURE nothing useful there, type "Y" then press Enter
echo for War2Insight automated restart (unsaved replay will be lost!)&echo.
set AskUser=
Set /p AskUser="Empty value or any another except "y" will terminate the script: "
if "%AskUser%"=="Y" call :InsClose &goto NoInsightRunning
if "%AskUser%"=="y" call :InsClose &goto NoInsightRunning
echo %time% User Exit.>>"%War2LLog%"
exit
:NoInsightRunning

set "IniPath=%CD%"
call :IniRead
if Not defined InsightsDir call :SelectFolder
if Not defined InsightsDir set "InsightsDir=%CD%\Insights"
if exist "%InsightsDir%" goto InsDirOK
if "%InsightsDir%" NEQ "%CD%\Insights" call :SelectFolder
if exist "%InsightsDir%" goto InsDirOK
echo %time:~0,8% --- Replay saving path not exist.
echo %time:~0,8% --- Trying to use ..\Insights directory by default.
echo %time% --- Replay saving path not exist.>>"%War2LLog%"
echo %time% Trying to use ..\Insights directory by default.>>"%War2LLog%"
set "InsightsDir=%CD%\Insights"
if exist "%InsightsDir%" goto InsDirOK
mkdir "%InsightsDir%"
if %errorlevel% EQU 0 goto InsDirOK
set "InsightsDir=%War2Dir%"
echo %time:~0,8% * Note : using default war2dir for insights.
echo %time% * Note : using default war2dir for insights.>>"%War2LLog%"
:InsDirOK
echo %time:~0,8% replays: "%InsightsDir%"
echo %time% replays: "%InsightsDir%" >>"%War2LLog%"
if "%InsightsDir%"=="%IniPath%" goto InsDirUnchanged
echo %InsightsDir%>"%CD%\War2InSightAutorecord.ini"
echo %time:~0,8% * Note : * autosave path has been changed.
echo %time% * Note : * autosave path has been changed.>>"%War2LLog%"
:InsDirUnchanged

:: cd /D "%InsightsDir%"
pushd "%InsightsDir%"
:: start "" /D "%InsightsDir%" /I "%War2Dir%\Utils\%War2Insight%"
start "" /D "%InsightsDir%" "%War2Dir%\Utils\%War2Insight%"
set erl=%errorlevel%
echo %time:~0,8%  erl %erl% : started \Utils\%War2Insight%
echo %time%  erl %erl% : started \Utils\%War2Insight%>>"%War2LLog%"
popd
:: cd /D "%War2Dir%"

call :sleepNN %War2LoadTime% >nul
if %war2NotRunning% GTR 0 start "" "%War2Dir%\%War2StartNN%"
set erl=%errorlevel%
echo %time:~0,8%  erl %erl% : started %War2StartNN%
echo %time%  erl %erl% : started %War2StartNN%>>"%War2LLog%"

set /a try=0
:War2Wait
set /a slp=%War2LoadTime%*2
call :sleepNN %slp% >nul
TaskList /FI "ImageName EQ Warcraft II BNE.exe" 2>nul | Find /I "Warcraft II BNE.exe" >nul
set /a war2NotRunning=%ErrorLevel%
if %war2NotRunning% EQU 0 goto War2Here
set /a try=%try%+1
if %try% GTR %War2WaitLim% echo %time:~0,8% Waiting limit [%War2WaitLim%] exceeded.&echo %time% Waiting limit [%War2WaitLim%] exceeded.>>"%War2LLog%" &exit /b 258
echo %time:~0,8% War2 still not running. Waiting...
echo %time% War2 still not running. Correct War2LoadTime / Remove restrictions.>>"%War2LLog%"
goto War2Wait

:War2Here
start "*Insight Autorecord*" /MIN "%War2Dir%\Utils\War2InSightAutorecord.exe"
set erl=%errorlevel%
echo %time:~0,8%  erl %erl% : started \Utils\War2InSightAutorecord.exe
echo %time%  erl %erl% : started \Utils\War2InSightAutorecord.exe>>"%War2LLog%"
echo --- %date% %time:~0,8% ready.&echo.&echo All Done. Exiting...&echo Log file: "%War2LLog%"
echo --- %date% %time% ready>>"%War2LLog%"
call :sleepNN 7 >nul
exit /b 0

:: --- [func]
:sleepNN
    set /a cnt=%1
    :loop2
    set ctime=%time:~7,-3%
    :loop1
    if /i %ctime%==%time:~7,-3% goto :loop1
    set /a cnt-=1
    if %cnt% GTR 0 goto :loop2
    exit /b 0

:InsClose
    echo.
    echo %time:~0,8% --- Closing previous war2insight.
    echo %time% --- Closing previous war2insight.>>"%War2LLog%"
    taskkill /im War2BNEInSight104.exe /f 2>nul 1>nul
    taskkill /im War2BNEInSight105RC1.exe /f 2>nul 1>nul
    taskkill /im War2BNEInSight105RC2.exe /f 2>nul 1>nul
    exit /b 0

:PatchClose
    taskkill /im War2InSightAutorecord.exe /f 2>nul 1>nul
    exit /b 0

:SelectFolder
 echo %time:~0,8% --- Folder selection started.
 echo %time% --- Folder selection started.>>"%War2LLog%"
for /f "tokens=2 delims=:" %%i in ('chcp') do (
    set sPrevCP=%%i
    chcp 1251 >nul
)
for /f "usebackq delims=" %%i in (
    `@"%systemroot%\system32\mshta.exe" "javascript:var objShellApp = new ActiveXObject('Shell.Application');var Folder = objShellApp.BrowseForFolder(0, 'Select a folder to save War2Insight replays automatically',1, '::{20D04FE0-3AEA-1069-A2D8-08002B30309D}');try {new ActiveXObject('Scripting.FileSystemObject').GetStandardStream(1).Write(Folder.Self.Path)};catch (e){};close();" ^
    1^|more`
) do set InsightsDir=%%i
chcp %sPrevCP% >nul
if defined InsightsDir exit /b 0
 echo %time:~0,8% --- Folder selection is canceled.
 echo %time% --- Folder selection is canceled.>>"%War2LLog%"
exit /b 0

:IniRead
if Not exist "%IniPath%\War2InSightAutorecord.ini" exit /b 0
set /p InsightsDir=<"%IniPath%\War2InSightAutorecord.ini"
set "IniPath=%InsightsDir%"
exit /b 0
